<template>
  <div>
    <q-list>
      <div v-if="config.editors.length">
        <draggable
          :list="config.editors"
          handle=".editor__drag-handle"
        >
          <q-item
            v-for="(editor, index) in config.editors"
            :key="index"
          >
            <editor
              :editor="editor"
              :available-fields="availableFields"
              @remove="removeEditor(index)"
              @edit="editEditor(index)"
            />
          </q-item>
        </draggable>
      </div>
      <div
        v-else
        class="text-grey text-italic q-pa-sm"
      >
        No added editors. Click button below to add one
      </div>
    </q-list>
    <q-btn
      icon="add"
      label="Add editor"
      color="green"
      class="q-mt-md"
      @click="addEditor"
    />
    <editor-editor
      :is-active="editingEditorIndex !== null"
      :editor="config.editors[editingEditorIndex]"
      @close="editingEditorIndex = null"
      :available-fields="availableFields"
    />
  </div>
</template>

<script>
  import { defaultCollectionEditor } from '../../../../../../utilities/migrateConfig';
  import Editor from './editor';
  import EditorEditor from './editorEditor';

  export default {
    name: 'editors',
    components: { EditorEditor, Editor },
    props: {
      config: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    data() {
      return {
        editingEditorIndex: null,
      };
    },
    methods: {
      removeEditor(index) {
        this.config.editors.splice(index, 1);
      },
      editEditor(index) {
        this.editingEditorIndex = index;
      },
      addEditor() {
        this.config.editors.push({ ...defaultCollectionEditor });
      },
    },
  };
</script>
